"use strict";
/**
  * @reach/auto-id v0.18.0
  *
  * Copyright (c) 2018-2022, React Training LLC
  *
  * This source code is licensed under the MIT license found in the
  * LICENSE.md file in the root directory of this source tree.
  *
  * @license MIT
  */

var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/reach-auto-id.ts
var reach_auto_id_exports = {};
__export(reach_auto_id_exports, {
  useId: () => useId
});
module.exports = __toCommonJS(reach_auto_id_exports);
var React = __toESM(require("react"));
var import_utils = require("@reach/utils");
var serverHandoffComplete = false;
var id = 0;
function genId() {
  return ++id;
}
var maybeReactUseId = React["useId".toString()];
function useId(providedId) {
  var _a;
  if (maybeReactUseId !== void 0) {
    let generatedId = maybeReactUseId();
    return providedId != null ? providedId : generatedId;
  }
  let initialId = providedId != null ? providedId : serverHandoffComplete ? genId() : null;
  let [id2, setId] = React.useState(initialId);
  (0, import_utils.useIsomorphicLayoutEffect)(() => {
    if (id2 === null) {
      setId(genId());
    }
  }, []);
  React.useEffect(() => {
    if (serverHandoffComplete === false) {
      serverHandoffComplete = true;
    }
  }, []);
  return (_a = providedId != null ? providedId : id2) != null ? _a : void 0;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useId
});
//# sourceMappingURL=reach-auto-id.cjs.dev.js.map